<!-- 
  RED.validators source code
  https://github.com/node-red/node-red/blob/8e7efd98b2c8ac2b387808dbf2f0c8ddd03b4858/packages/node_modules/%40node-red/editor-client/src/js/validators.js
 -->
 <style>
  .unitid-count {
    width: 100% !important;
  }

  .adr-count {
    width: 100% !important;
  }

  .quantity-count {
    width: 100% !important;
  }      
</style>

<script type="text/javascript">
  function validateNumberRange(v, min, max){      
    return (v!=='' && !isNaN(v)) && ((Number(v) >= min) && Number(v) <= max)
  }
  RED.nodes.registerType('modbus-editor', {
    category: 'nilvana',
    color: '#EABD93',    
    defaults: {
      name: {value: ''},
      topic: {value: ''},
      showStatusActivities: {value: true},
      showErrors: {value: true},
      unitid: {value: 1, required: true, validate: function(v){
        return validateNumberRange(v, 0, 255)
      }},
      dataType: {value: '', required: true, validate:function (v){        
        return ('R_Coil' == v ||
                'R_Input' == v || 
                'R_HoldingRegister' == v || 
                'R_InputRegister' == v|| 
                'W_Coil' == v || 
                'W_HoldingRegister' == v|| 
                'W_MCoils' == v || 
                'W_MHoldingRegisters' == v)
              }
      },
      adr: {value: 0, required: true, validate: function(v){        
        return validateNumberRange(v, 0, 65535)
      }},
      quantity: {value: 1, required: true, validate: function(v){
        // return ((v!=='' && !isNaN(v)) && ((Number(v) >= 1) && Number(v) <= 65535))
        return validateNumberRange(v, 1, 65535)
      }},
      server: {type: 'modbus-client', required: true},
      emptyMsgOnFail: {value: true},
      keepMsgProperties: {value: false}
    },
    inputs: 1,
    outputs: 2,
    align: "left",
    icon: 'modbus.png',    
    paletteLabel: 'Modbus-Editor',
    label: function () {
      return this.name || 'Modbus Editor'
    },
    oneditprepare: function () {
      let previous = null
      let node = this
      let fcDataTypeSelector = $('#node-input-dataType')
      let quantitySelector = $('#node-input-quantity')
      let modbusQuantityRow = $('#modbus-quantity')

      $(".unitid-count").spinner({
        max:255,
        min: 0
      });

      $(".adr-count").spinner({
        max:65535,
        min: 0
      });
      $(".quantity-count").spinner({
        max:65535,
        min: 1
      });

      fcDataTypeSelector.on('focus', function () {
        previous = this.value
      }).change(function () {
        if (previous == null) {
          previous = fcDataTypeSelector.val()
        }

        switch (fcDataTypeSelector.val()) {
          case 'R_Coil':
          case 'R_Input':
          case 'R_HoldingRegister':
          case 'R_InputRegister':
            node.quantity.required = true
            modbusQuantityRow.show()
            break
          case 'W_Coil':
          case 'W_HoldingRegister':
            node.quantity.required = false
            modbusQuantityRow.hide()
            quantitySelector.val(1)
            break
          case 'W_MCoils':
          case 'W_MHoldingRegisters':
            node.quantity.required = true
            modbusQuantityRow.show()
            break
          default:
            console.log("function code not support !!", fcDataTypeSelector.val())
        }
      })
    }
  })
</script>


<script type="text/x-red" data-template-name="modbus-editor">    
    <div class="form-row">
      <label for="node-input-server"><i class="fa fa-server"></i> <span data-i18n="modbus-contrib.label.server"></span></label>
      <input type="text" id="node-input-server">
    </div>
    <div class="form-row">
        <label for="node-input-unitid"><i class="fa fa-bookmark"></i> <span data-i18n="modbus-contrib.label.unitId"></span></label>
        <input type="text" id="node-input-unitid" class="unitid-count">
    </div>
    <div class="form-row">
        <label for="node-input-dataType"><i class="fa fa-list-ol"></i> <span data-i18n="modbus-contrib.label.functioncode"></span></label>
        <select id="node-input-dataType">
            <option value="R_Coil">FC 1: Read Coil Status</option>
            <option value="R_Input">FC 2: Read Input Status</option>
            <option value="R_HoldingRegister">FC 3: Read Holding Registers</option>
            <option value="R_InputRegister">FC 4: Read Input Registers</option>
            <option value="W_Coil">FC 5: Force Single Coil</option>
            <option value="W_HoldingRegister">FC 6: Preset Single Register</option>
            <option value="W_MCoils">FC 15: Force Multiple Coils</option>
            <option value="W_MHoldingRegisters">FC 16: Preset Multiple Registers</option>
        </select>
    </div>
    <div class="form-row">
        <label for="node-input-adr"><i class="fa fa-bookmark"></i> <span data-i18n="modbus-contrib.label.address"></span></label>
        <input type="text" id="node-input-adr" placeholder="0-65535" class="adr-count">
    </div>
    <div class="form-row" id="modbus-quantity">
        <label for="node-input-quantity"><i class="fa fa-bookmark"></i> <span data-i18n="modbus-contrib.label.quantity"></span></label>
        <input type="text" id="node-input-quantity" placeholder="1-65535" class="quantity-count">
    </div>
    <div class="form-row">
      <label for="node-input-name"><i class="fa fa-tag"></i> Name</label>
      <input type="text" id="node-input-name" placeholder="Name">
    </div>
<!--     
    <hr>
    <div class="form-row">
        <label style="min-width:160px" for="node-input-emptyMsgOnFail"><i class="fa fa-th"></i> <span
        data-i18n="modbus-contrib.label.emptyMsgOnFail"></span></label>
        <input type="checkbox" id="node-input-emptyMsgOnFail" style="max-width:30px">
    </div>
    <div class="form-row">
        <label style="min-width:160px" for="node-input-keepMsgProperties"><i class="fa fa-th"></i> <span
        data-i18n="modbus-contrib.label.keepMsgProperties"></span></label>
        <input type="checkbox" id="node-input-keepMsgProperties" style="max-width:30px">
    </div>
    <div class="form-row">
        <label style="min-width:160px" for="node-input-showStatusActivities"><i class="fa fa-th"></i> <span
        data-i18n="modbus-contrib.label.showActivities"></span></label>
        <input type="checkbox" id="node-input-showStatusActivities" style="max-width:30px">
    </div>
    <div class="form-row">
        <label style="min-width:160px" for="node-input-showErrors"><i class="fa fa-th"></i> <span
        data-i18n="modbus-contrib.label.showErrors"></span></label>
        <input type="checkbox" id="node-input-showErrors" style="max-width:30px">
    </div> -->

</script>
